con

  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000                                          ' use 5MHz crystal
' _xinfreq = 6_250_000                                          ' use 6.25MHz crystal

  CLK_FREQ = ((_clkmode - xtal1) >> 6) * _xinfreq
  MS_001   = CLK_FREQ / 1_000
  US_001   = CLK_FREQ / 1_000_000

  basebin  = 16
  numpings = 3
  TO_IN = 73_746                                                                ' Inches
  null = 0
  fifteen = %1111111111111111
VAR
  long  setpin,setqty,setmem
  long cog

PUB Start(bpin,qty,basemem)
  setpin := bpin
  setqty:= qty
  setmem:= basemem
  cog := cognew (@entry,@setpin)+1
  
  return cog
  

dat
entry   org   0
        mov             t1,PAR
        rdlong          pin,t1
        add             t1,#4
        rdlong          numreps,t1
        add             t1,#4
        rdlong          hubbase,t1
loop1   mov             hubptr,hubbase
        mov             pinctr,pin
        mov             pinmask,#1
        shl             pinmask,pinctr
        mov             repcnt,numreps
loop2   or              outa,pinmask
        or              dira,pinmask
        mov             dlycnt,delay5
        add             dlycnt,cnt
        waitcnt         dlycnt,null
        andn            outa,pinmask
        andn            dira,pinmask
        waitpne         null,pinmask
        mov             startcnt,cnt
        waitpeq         null,pinmask
        mov             endcnt,cnt
        sub             endcnt,startcnt         WC       'if rollover sets carry
        negc            cnttotal,endcnt                  ' mov or neg depending on c 
        shr             cnttotal,#1                      'divide by 2 for oneway time
        wrlong          cnttotal,hubptr
        add             hubptr,#4
        add             pinctr,#1
        add             pinctr2,#1
        mov             pinmask,#1
        shl             pinmask,pinctr
        shl             pinmask2,pinctr2
        djnz            repcnt,#loop2
        mov             dlycnt,delay1000
        add             dlycnt,cnt
        waitcnt         dlycnt,null
        jmp             #loop1
        
delay2        long              (US_001*2)       '2 microsecond delay
delay5        long              (US_001 * 5)     '5 microsecond delay for ping turnaround
delay200      long              (US_001 * 200)   '200 microsecond delay for ping repeat
delay5000     long              (us_001 * 5000)
delay1000     long              (MS_001*1000)     '1 second delay
:null         long              0
pin           res               1
pinmask       res               1
pinmask2      res               1
pinctr        res               1
pinctr2       res               1
numreps       res               1
hubbase       res               1
hubptr        res               1
repcnt        res               1
dlycnt        res               1
startcnt      res               1
endcnt        res               1 
cnttotal      res               1
t1            res               1
t2            res               1                  